## net.sf.saxon.event
Interface Receiver

All Superinterfaces:
  javax.xml.transform.Result

All Known Implementing Classes:
  Builder, Emitter, ProxyReceiver, SequenceReceiver

public interface Receiver
extends javax.xml.transform.Result

Receiver: This interface represents a recipient of XML tree-walking events. It is based on SAX2's ContentHandler, but adapted to handle additional events, and to use Saxon's name pool. Namespaces and Attributes are handled by separate events following the startElement event. Schema types can be defined for elements and attributes.

Field Summary

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Method Summary
`void` `attribute(int nameCode, int typeCode, java.lang.CharSequence value, int locationId, int properties)` Notify an attribute.
`void` `characters(java.lang.CharSequence chars, int locationId, int properties)` Notify character data.
`void` `close()` Notify the end of the event stream
`void` `comment(java.lang.CharSequence content, int locationId, int properties)` Notify a comment.
`void` `endDocument()` Notify the end of a document node
`void` `endElement()` Notify the end of an element.
`Configuration` `getConfiguration()` Get the configuration
`LocationProvider` `getDocumentLocator()` Get the LocationProvider previously set using setDocumentLocator
`void` `namespace(int namespaceCode, int properties)` Notify a namespace.
`void` `open()` Notify the start of the event stream
`void` `processingInstruction(java.lang.String name, java.lang.CharSequence data, int locationId, int properties)` Output a processing instruction
`void` `setConfiguration(Configuration config)` Set the configuration
`void` `setDocumentLocator(LocationProvider locator)` Set location provider, to identify position in the source document or stylesheet.
`void` `setSystemId(java.lang.String systemId)` Set the System ID of the destination tree
`void` `setUnparsedEntity(java.lang.String name, java.lang.String systemID, java.lang.String publicID)` Notify an unparsed entity URI.
`void` `startContent()` Notify the start of the content, that is, the completion of all attributes and namespaces.
`void` `startDocument(int properties)` Notify the start of a document node
`void` `startElement(int nameCode, int typeCode, int locationId, int properties)` Notify the start of an element

Methods inherited from interface javax.xml.transform.Result
`getSystemId`

Method Detail

### setConfiguration

    public void setConfiguration(Configuration config)

  Set the configuration

### getConfiguration

    public Configuration getConfiguration()

  Get the configuration

### setSystemId

    public void setSystemId(java.lang.String systemId)

  Set the System ID of the destination tree

  Specified by:
    `setSystemId` in interface `javax.xml.transform.Result`

### setDocumentLocator

    public void setDocumentLocator(LocationProvider locator)

  Set location provider, to identify position in the source document or stylesheet. This method may only be called before the startDocument() event. However, the locator returned by the location provider may be different on different occasions. If a location provider is supplied, it may be used by the Receiver to obtain information about the location of the current event in a source XML document.

### getDocumentLocator

    public LocationProvider getDocumentLocator()

  Get the LocationProvider previously set using setDocumentLocator

### open

    public void open()
              throws XPathException

  Notify the start of the event stream

    `XPathException`

### startDocument

    public void startDocument(int properties)
                       throws XPathException

  Notify the start of a document node

    `XPathException`

### endDocument

    public void endDocument()
                     throws XPathException

  Notify the end of a document node

    `XPathException`

### setUnparsedEntity

    public void setUnparsedEntity(java.lang.String name,
                                  java.lang.String systemID,
                                  java.lang.String publicID)
                           throws XPathException

  Notify an unparsed entity URI.

  Parameters:
    `name` - The name of the unparsed entity
    `systemID` - The system identifier of the unparsed entity
    `publicID` - The public identifier of the unparsed entity
    `XPathException`

### startElement

    public void startElement(int nameCode,
                             int typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  Notify the start of an element

  Parameters:
    `nameCode` - integer code identifying the name of the element within the name pool.
    `typeCode` - integer code identifying the element's type within the name pool. The value -1 indicates the default type, xdt:untyped.
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `XPathException`

### namespace

    public void namespace(int namespaceCode,
                          int properties)
                   throws XPathException

  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element; however, duplicates may be reported. A namespace must not conflict with any namespaces already used for element or attribute names.

  Parameters:
    `namespaceCode` - an integer: the top half is a prefix code, the bottom half a URI code. These may be translated into an actual prefix and URI using the name pool. A prefix code of zero represents the empty prefix (that is, the default namespace). A URI code of zero represents a URI of "", that is, a namespace undeclaration.
  Throws:
    `IllegalStateException:` - attempt to output a namespace when there is no open element start tag
    `XPathException`

### attribute

    public void attribute(int nameCode,
                          int typeCode,
                          java.lang.CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.

  Parameters:
    `nameCode` - The name of the attribute, as held in the name pool
    `typeCode` - The type of the attribute, as held in the name pool
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this attribute
  NO_SPECIAL_CHARACTERS
    Attribute value contains no special characters
  Throws:
    `IllegalStateException:` - attempt to output an attribute when there is no open element start tag
    `XPathException`

### startContent

    public void startContent()
                      throws XPathException

  Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial receiver of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.

    `XPathException`

### endElement

    public void endElement()
                    throws XPathException

  Notify the end of an element. The receiver must maintain a stack if it needs to know which element is ending.

    `XPathException`

### characters

    public void characters(java.lang.CharSequence chars,
                           int locationId,
                           int properties)
                    throws XPathException

  Notify character data. Note that some receivers may require the character data to be sent in a single event, but in general this is not a requirement.

  Parameters:
    `chars` - The characters
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this text node
  USE_CDATA
    Output as a CDATA section
  NO_SPECIAL_CHARACTERS
    Value contains no special characters
  WHITESPACE
    Text is all whitespace
    `XPathException`

### processingInstruction

    public void processingInstruction(java.lang.String name,
                                      java.lang.CharSequence data,
                                      int locationId,
                                      int properties)
                               throws XPathException

  Output a processing instruction

  Parameters:
    `name` - The PI name. This must be a legal name (it will not be checked).
    `data` - The data portion of the processing instruction
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the PI. The following bits are defined:
  CHECKED
    Data is known to be legal (e.g. doesn't contain "?>")
  Throws:
    `IllegalArgumentException:` - the content is invalid for an XML processing instruction
    `XPathException`

### comment

    public void comment(java.lang.CharSequence content,
                        int locationId,
                        int properties)
                 throws XPathException

  Notify a comment. Comments are only notified if they are outside the DTD.

  Parameters:
    `content` - The content of the comment
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the comment. The following bits are defined:
  CHECKED
    Comment is known to be legal (e.g. doesn't contain "--")
  Throws:
    `IllegalArgumentException:` - the content is invalid for an XML comment
    `XPathException`

### close

    public void close()
               throws XPathException

  Notify the end of the event stream

    `XPathException`